MAIN
   DEFINE choose SMALLINT
   DEFINE l_addItem SMALLINT
   DEFINE l_sAux STRING 

  LET choose = 1 
  LET l_addItem = 2
   
   OPEN WINDOW w_radioGroup WITH FORM "radiogroup"
   
   INPUT BY NAME choose
      ATTRIBUTES(UNBUFFERED, WITHOUT DEFAULTS)

      ON ACTION ACCEPT
         LET l_sAux =  "your choice: ", choose USING "#&"
         CALL fgl_winMessage("RadioGroup", l_sAux, "information")
         CONTINUE INPUT
         
      ON ACTION addOption
         CALL addOption(dialog.getForm(), "formonly.choose", (l_addItem:=(l_addItem+1)))
   END INPUT 
   

END MAIN 

#---
# Add an option to the radioGroup
#---
PRIVATE FUNCTION addOption(p_form, p_fieldName, p_option)
   DEFINE p_form ui.Form 
   DEFINE p_fieldName STRING 
   DEFINE p_option SMALLINT 
   DEFINE l_oFormNode, l_oField, l_oRadio, l_oItem om.domNode
   DEFINE l_nFormField om.NodeList
   DEFINE l_bAux BOOLEAN
   DEFINE i SMALLINT

   # get Form Node 
   IF (l_oFormNode := p_form.getNode()) IS NOT NULL THEN
      # get a list of FormFields
      LET l_nFormField = l_oFormNode.selectByTagName("FormField")
      IF l_nFormField.getLength() > 0 THEN
         LET i = 0
         LET l_bAux = FALSE
         # serach for the field's node 
         WHILE (i:=(i+1)) <= l_nFormField.getLength() AND NOT l_bAux
            LET l_oField = l_nFormField.item(i)
            IF 
               ( l_bAux := (l_oField.getAttribute("name") == p_fieldName)) 
            THEN
               # found it. Check if it has child nodes and
               # if the first child is indeed a radioGroup
               IF (l_oField.getChildCount() > 0 ) THEN
                  LET l_oRadio = l_oField.getFirstChild()
                  IF (l_oRadio.getTagName() == "RadioGroup") THEN
                     # finally: add option
                     IF (l_oItem := l_oRadio.createChild("Item")) IS NOT NULL THEN
                        # set Item attributes
                        CALL l_oItem.setAttribute("name", p_option USING "<&")
                        CALL l_oItem.setAttribute("text", "Option "||l_oItem.getAttribute("name"))
                     END IF 
                  END IF 
               END IF 
            END IF 
         END WHILE 
      END IF 
   END IF    
END FUNCTION 